        PAGE ,132
        TITLE MIPS code => 8088.
        NAME  EXAMP2

        COMMENT |
19 April 2011, SRN, whatever.  Translate Clive's MIPS program to
partly non-working 8088/MS-DOS program code.

   To create a working program witn MASM 5.0, do the following
commands.  (Or use a different version assembler.)

MASM EXAMP2                     : This might be an ML command.
LINK EXAMP2                     : This might be a LINK16 command.
                                : Expect a no stack warning.
EXE2BIN EXAMP2.EXE EXAMP2.COM
                |

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; Set up the code definitions the operating system wants.
; In a COM program all segments are the same.

CODE    SEGMENT
        ORG     100H
        ASSUME  CS:CODE,DS:CODE

START:
        JMP     Start_1 ; Jump over data to start of program.
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; Data Area

;  # Assumes no Load Delays, and no Delay Slots for branches
; Does not apply...
;  .data

;  str1:   .ascii "Please type in integer, then ENTER.\n"
str1    DB      'Please type in integer, then ENTER.', 13, 10, '$'

;  .asciiz "The input is converted to binary.\n"
        DB      'The input is converted to binary.', 13, 10, '$'

;  askint: .asciiz "\n?-> "
askint  DB      13, 10, '?-> $'

;  answstr:.asciiz "The binary value is: "
answstr DB      'The binary value is: $'

;  crlf:   .asciiz "\n\n"
crlf   DB       13, 10, 13, 10, '$'

;  strbuf: .asciiz "1234567890123456789012345678901234567890" # 40 chars
strbuf DB       '1234567890123456789012345678901234567890'      ; 40 chars

;  nof scratch
;??
;  .text

Start_1:        ; This is the starting point for the program code.
        PUSH    CS      ;\ Safety code if you forget to convert the
        POP     DS      ;/ *.EXE to *.COM.
        PUSH    CS      ;\
        POP     ES      ;/

;  main:   li      $v0, 4          # Print String
;  la      $a0, str1               # load address str1
;  syscall
        MOV     DX,OFFSET str1  ; load address str1
        MOV     AH,9            ; DOS Print String to console
        INT     21H             ; DOS syscall

;  li      $v0, 4                  # Print String
;  la      $a0, askint             # load address askint
;  syscall
        MOV     DX,OFFSET askint ; load address askint
        MOV     AH,9            ; DOS Print String to console
        INT     21H             ; DOS syscall

;  li      $v0, 5                  # Read Integer into $v0
;  syscall
;!!     CALL Subroutine         ; MS-DOS has no integer input function,
        MOV     AX,1234         ; use a provided routine or write your own.
                                ; I am just putting an integer into AX.

;  move    $t0, $v0
        MOV     DX,AX           ; Assume integer in AX, store a copy in DX.

;  la      $a0, strbuf             # load address of string buffer
;  li      $t2, 32                 # Bit Count, i = 32
        MOV     DI,OFFSET strbuf ; load address of string buffer
        MOV     CX,16           ; Bit Count, i = 16

;  binary:
binary:

;  srl     $t1, $t0, 31            # t1 = t0 >> 31
;  addiu   $t1, $t1, 48            # t1 = t1 + '0'
        MOV     AX,DX           ; Make temporary copy of integer.
REPT    15
        SHR     AX,1            ;  t1 = t0 >> 15
ENDM
        ADD     AX,'0'          ; t1 = t1 + '0'

;  sb      $t1, 0($a0)             # Store Byte [$a0] = $t1
;  addiu   $a0, $a0, 1             # $a0++
        STOSB                   ; Store Byte [$a0] = $t1
                                ; $a0++

;  sll     $t0, $t0, 1             # t0 = t0 << 1
        SHL     DX,1            ; t0 = t0 << 1

;  addiu   $t2, $t2, -1            # i--
;  bne     $t2, $zero, binary
        LOOP    binary          ; i--, and the bne.

;  sb      $zero, 0($a0)           # Terminate string with NUL
        MOV     AL,'$'
        STOSB                   ; Terminate DOS string with '$'.

;  li      $v0, 4                  # Print String
;  la      $a0, answstr            # Answer Message
;  syscall
        MOV     DX,OFFSET answstr ; Answer Message
        MOV     AH,9            ; DOS Print String to console
        INT     21H             ; DOS syscall

;  li      $v0, 4                  # Print String
;  la      $a0, strbuf             # string buffer with binary ascii
;  syscall
        MOV     DX,OFFSET strbuf ; string buffer with binary ascii
        MOV     AH,9            ; DOS Print String to console
        INT     21H             ; DOS syscall

;  li      $v0, 4                  # Print String
;  la      $a0, crlf               # Carriage Return, Line Feed
;  syscall
        MOV     DX,OFFSET crlf  ; Carriage Return, Line Feed
        MOV     AH,9            ; DOS Print String to console
        INT     21H             ; DOS syscall

;  li      $v0, 10                 # Exit
;  syscall
        MOV     AH,4CH          ; DOS 2.x+ Exit
        INT     21H             ; DOS syscall

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CODE    ENDS            ; Close CODE segemnt
        END     START   ; END + Bogus program entry point for EXE.
